"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.MeshBakedMaterial = void 0;
const THREE = __importStar(require("three"));
const before = `totalDiffuse + totalSpecular + totalEmissiveRadiance`;
const after = `sampledDiffuseColor.rgb + reflectedLight.indirectDiffuse + totalSpecular + totalEmissiveRadiance`;
/** Drop-in replacement for MeshStandardMaterial that is useful for baked textures. */
class MeshBakedMaterial extends THREE.MeshStandardMaterial {
    constructor(parameters) {
        super(parameters);
        let userProvidedOnBeforeCompile = (shader) => { };
        // Replace the a line in the shader code with our own:
        const onBeforeCompile = (shader) => {
            shader.fragmentShader = shader.fragmentShader.replace(before, after);
            userProvidedOnBeforeCompile(shader);
        };
        // Do some magic so that we can still call the user-provided onBeforeCompile function:
        Object.defineProperty(this, 'onBeforeCompile', {
            set: (handler) => {
                userProvidedOnBeforeCompile = handler;
            },
            get: () => {
                return onBeforeCompile;
            }
        });
    }
}
exports.MeshBakedMaterial = MeshBakedMaterial;
